from PyQt5.QtWidgets import QMainWindow
from gui.gridui import Ui_GridDialog


class GridDialog(QMainWindow, Ui_GridDialog):
    def __init__(self, _appctrl):
        super().__init__()
        super().setupUi(self)

        # App controller
        self.appController = _appctrl

        # Line edit input mask
        self.lineEditXdir.setInputMask("9.99")
        self.lineEditYdir.setInputMask("9.99")

        # Grid Actions
        self.lineEditXdir.textEdited.connect(self.appController.gridChangeGrid)
        self.lineEditYdir.textEdited.connect(self.appController.gridChangeGrid)
        self.checkBoxSnap.clicked.connect(self.appController.gridChangeGrid)
        self.closeButton.clicked.connect(self.appController.gridClose)

    def closeEvent(self, _event):
        self.appController.gridCloseEvent()
        _event.accept()
