from PyQt5.QtWidgets import QMainWindow
from gui.meshsegmentui import Ui_MeshSegmentDialog


class MeshSegmentDialog(QMainWindow, Ui_MeshSegmentDialog):
    def __init__(self, _appctrl):
        super().__init__()
        super().setupUi(self)

        # App controller
        self.appController = _appctrl

        # Line edit input mask
        self.lineEditNumSubdiv.setInputMask("99")
        self.lineEditRatio.setInputMask("9.99")

        # Mesh Segment Actions
        self.buttonApply.clicked.connect(self.appController.meshSegmentApply)
        self.buttonClose.clicked.connect(self.appController.meshSegmentClose)

    def closeEvent(self, _event):
        self.appController.meshSegmentCloseEvent()
        _event.accept()
